
;-  Add your game description here for LogoSmash
;
;
UsePNGImageDecoder()
UseJPEGImageDecoder()
UseJPEG2000ImageDecoder()
UseGIFImageDecoder()

Global *a.cpSprite
Global *b.cpSprite

Procedure make_ball(x.cpFloat, y.cpFloat)
  *a = AllocateStructure(cpSprite)
  
  *a\body = cpBodyNew(1.0, #INFINITY);
  cpBodySetPosition(*a\body, cpv(_A, x, y)) ;
  
  *a\shape = cpCircleShapeNew(*a\body, 2, cpvzero);
  cpShapeSetElasticity(*a\shape, 0.0)             ;
  cpShapeSetFriction(*a\shape, 0.0)               ;
  
  cpShapeSetUserData(*a\shape, *a)
  
  ProcedureReturn *a;
EndProcedure

Procedure initFuncLogoSmash()
  initFunc()
  SetChipmunk4PBDebugFlag(0)
  
  cpSpaceSetIterations(*space, 10);
  cpSpaceSetGravity(*space, cpv(_A,0, 0));
  
  #maxx = 200
  #maxy = 200
  
  LoadImage(0,".\Demos\images\PureBasic_Z.jpg")
  While ImageHeight(0) > #maxx Or ImageWidth(0) > #maxy
    ResizeImage(0, ImageHeight(0)/2,ImageWidth(0)/2)
  Wend
 
  
  ;// The space will contain a very large number of similary sized objects.
  ;// This is the perfect candidate For using the spatial hash.
  ;// Generally you will never need To do this.
  cpSpaceUseSpatialHash(*space, 16.0, 10000);
  
  *body.cpBody
  *shape.cpShape
  
  dd.i = 4
  color = 0
  For y = 0 To ImageHeight(0)-1 Step 2
    For x = 0 To ImageWidth(0)-1 Step 2
      StartDrawing(ImageOutput(0))
      color = Point(x,y);
      StopDrawing()
      If color <> #Black
        *a = make_ball(wx/2 + x*dd-ImageWidth(0)*dd/2, wy/2 + y*dd-ImageHeight(0)*dd/2)
        cpSpaceAddBody(*space, *a\body)                                  
        cpSpaceAddShape(*space, *a\shape)                                                    
        
        CompilerIf Subsystem("DX9")
          Image = CreateImage(#PB_Any, dd*2,dd*2)
          StartDrawing(ImageOutput(Image))
          Circle(2,2,2,color)
          StopDrawing()
          Texture = MP_ImageToTexture(Image)  
          *mouseSprite\spriteID  = MP_SpriteFromTexture(Texture) 
        CompilerElse
          *a\SpriteID = CreateSprite(#PB_Any,dd*2,dd*2)
          StartDrawing(SpriteOutput(*a\SpriteID))
          Circle(2,2,2,color)
          StopDrawing()
        CompilerEndIf
      EndIf   
    Next
  Next
  
  
  ; left to right
  *a = AllocateStructure(cpSprite)
  *a\body = cpSpaceAddBody(*space, cpBodyNew(1e9, #INFINITY))
  cpBodySetPosition(*a\body, cpv(_A, -400, wy/2+15))             
  cpBodySetVelocity(*a\body, cpv(_A, 400, 0))                
  *a\shape = cpSpaceAddShape(*space, cpCircleShapeNew(*a\body, 16.0, cpvzero))
  cpShapeSetElasticity(*a\shape, 1.0)                                      
  cpShapeSetFriction(*a\shape, 0.0)    
  *a\SpriteID = CreateSprite(#PB_Any,32,32)
  StartDrawing(SpriteOutput(*a\SpriteID))
  Circle(16,16,16,#Green)
  StopDrawing()
  cpShapeSetUserData(*a\shape, *a)
  

  
  ; right to left
  *a = AllocateStructure(cpSprite)
  *a\body = cpSpaceAddBody(*space, cpBodyNew(1e9, #INFINITY))
  cpBodySetPosition(*a\body, cpv(_A, wx+400, wy/2-15))        
  cpBodySetVelocity(*a\body, cpv(_A, -400, 0))       
  *a\shape = cpSpaceAddShape(*space, cpCircleShapeNew(*a\body, 16.0, cpvzero))
  cpShapeSetElasticity(*a\shape, 0.8)                                      
  cpShapeSetFriction(*a\shape, 0.0)    
  *a\SpriteID = CreateSprite(#PB_Any,32,32)
  StartDrawing(SpriteOutput(*a\SpriteID))
  Circle(16,16,16,#Yellow)
  StopDrawing()
  cpShapeSetUserData(*a\shape, *a)
  
  ; top to bottom
  *a = AllocateStructure(cpSprite)
  *a\body = cpSpaceAddBody(*space, cpBodyNew(1e9, #INFINITY))
  cpBodySetPosition(*a\body, cpv(_A, wx/2-25, -400))          
  cpBodySetVelocity(*a\body, cpv(_A, 0, 400))          
  *a\shape = cpSpaceAddShape(*space, cpCircleShapeNew(*a\body, 16.0, cpvzero))
  cpShapeSetElasticity(*a\shape, 0.8)                                      
  cpShapeSetFriction(*a\shape, 0.0)  
  *a\SpriteID = CreateSprite(#PB_Any,32,32)
  StartDrawing(SpriteOutput(*a\SpriteID))
  Circle(16,16,16,#Red)
  StopDrawing()
  cpShapeSetUserData(*a\shape, *a)
  
  
  ; top to bottom
  *a = AllocateStructure(cpSprite)
  *a\body = cpSpaceAddBody(*space, cpBodyNew(1e9, #INFINITY))
  cpBodySetPosition(*a\body, cpv(_A, wx/2+25, wy+400))          
  cpBodySetVelocity(*a\body, cpv(_A, 0, -400))          
  *a\shape = cpSpaceAddShape(*space, cpCircleShapeNew(*a\body, 16.0, cpvzero))
  cpShapeSetElasticity(*a\shape, 0.8)                                      
  cpShapeSetFriction(*a\shape, 0.0)  
  *a\SpriteID = CreateSprite(#PB_Any,32,32)
  StartDrawing(SpriteOutput(*a\SpriteID))
  Circle(16,16,16,#Blue)
  StopDrawing()
  cpShapeSetUserData(*a\shape, *a)
  
EndProcedure


Procedure updateFuncLogoSmash()
  updateFunc()
EndProcedure


Procedure destroyFuncLogoSmash()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "LogoSmash"
ChipmunkDemo()\timestep = 1.0/60
ChipmunkDemo()\initFunc = @initFuncLogoSmash()
ChipmunkDemo()\updateFunc = @updateFuncLogoSmash()
ChipmunkDemo()\destroyFunc = @destroyFuncLogoSmash()


; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 114
; FirstLine = 104
; Folding = -
; EnableXP
; DisableDebugger