;-  Add your game description here for OneWay
;
;

Enumeration CollisionTypes 
  #COLLISION_TYPE_ONE_WAY = 1
EndEnumeration

; Structure OneWayPlatform 
;   n.cpVect; // direction objects may pass through
; EndStructure


Global *sprite.cpSprite = #Null
Global platformInstance.cpVect

ProcedureC PreSolve(*arb.cpArbiter, *space.cpSpace, *ignore)
  Dim *aShape.cpShape(11)
  Dim *bShape.cpShape(11)
  
  cpArbiterGetShapes(*arb, *aShape(), *bShape())     
  *as.cpSprite = cpShapeGetUserData(*aShape(0)) 

  If cpvdot(cpArbiterGetNormal(_A, *arb), *as\data) > 0.0
    ProcedureReturn cpArbiterIgnore(*arb)
  EndIf
  
  ProcedureReturn #True;
EndProcedure




Procedure initFuncOneWay()
  initFunc()
  SetChipmunk4PBDebugFlag(1)
  
  cpSpaceSetIterations(*space, 10)
  cpSpaceSetGravity(*space, cpv(_A,0, 50))
  
  *sprite = AllocateStructure(cpSprite)
  *shape.cpShape   
  
  cpSetBorderLines() ; Create segments around the edge of the screen.
  
  
  ;	// Add our one way segment
  *sprite\shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,100,wy-300), cpv(_B, 500,wy-300), 0.0))
  cpShapeSetElasticity(*sprite\shape, 1.0)                                                                             
  cpShapeSetFriction(*sprite\shape, 1.0)                                                                               
  cpShapeSetCollisionType(*sprite\shape, #COLLISION_TYPE_ONE_WAY)                                                      
  cpShapeSetFilter(*sprite\shape, NOT_GRABBABLE_FILTER)        
  cpShapeSetFriction(*sprite\shape, 0.0)     
  ; // We'll use the data pointer for the OneWayPlatform struct
  *sprite\data = cpv(platformInstance, 0.0, 1.0)
  cpShapeSetUserData(*sprite\shape, *sprite)


  
  ; // Add a ball To test it out
  radius.cpFloat = 15.0;
  *body = cpSpaceAddBody(*space, cpBodyNew(10.0, cpMomentForCircle(10.0, 0.0, radius, cpvzero)))
  cpBodySetPosition(*body, cpv(_A, wx/2, wx))                                                   
  cpBodySetVelocity(*body, cpv(_B, 0, -200))                                                    
  
  *shape = cpSpaceAddShape(*space, cpCircleShapeNew(*body, radius, cpvzero))
  cpShapeSetElasticity(*shape, 0.0)                                         
  cpShapeSetFriction(*shape, 0.9)                                           
  cpShapeSetCollisionType(*shape, 2)                                        
  
  *handler.cpCollisionHandler = cpSpaceAddWildcardHandler(*space, #COLLISION_TYPE_ONE_WAY)
  *handler\cpCollisionPreSolveFunc = @PreSolve()                                          
  
EndProcedure


Procedure updateFuncOneWay()
  updateFunc()
EndProcedure


Procedure destroyFuncOneWay()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "OneWay"
ChipmunkDemo()\timestep = 1.0/20
ChipmunkDemo()\initFunc = @initFuncOneWay()
ChipmunkDemo()\updateFunc = @updateFuncOneWay()
ChipmunkDemo()\destroyFunc = @destroyFuncOneWay()
ChipmunkDemo()\description = "One way platforms are trivial in Chipmunk using a very simple collision callback.";

; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 47
; FirstLine = 26
; Folding = -
; EnableXP