



;-  Add your game description here for Tank
;
;
Global *tankBody.cpBody 
Global *tankControlBody.cpBody 

Global direction.cpFloat

Procedure add_box_tank(*space.cpSpace,  size.cpFloat,  mass.cpFloat) 
  radius.cpFloat = cpvlength(cpv(_A,size, size));
  
  *body.cpBody = cpSpaceAddBody(*space, cpBodyNew(mass, cpMomentForBox(mass, size, size)))
  cpBodySetPosition(*body, cpv(_A,Random(wx-radius,radius),Random(wy-radius, radius)))
  
  *shape = cpSpaceAddShape(*space, cpBoxShapeNew(*body, size, size, 0.0));
  cpShapeSetElasticity(*shape, 0.0)                                      ;
  cpShapeSetFriction(*shape, 0.7)                                        ;
  
  ProcedureReturn *body;
EndProcedure


Procedure initFuncTank()
  initFunc()
  SetChipmunk4PBDebugFlag(1)

  *staticBody.cpBody = cpSpaceGetStaticBody(*space);
  *shape.cpShape                                   ;
  
  ; Create segments around the edge of the screen.
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,0), cpv(_B,0,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                               
  cpShapeSetFriction(*shape, 1.0)                                                                 
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,0,wy-1), cpv(_B,wx-1,wy-1), 0.0))
  cpShapeSetElasticity(*shape, 1.0)                                                                       
  cpShapeSetFriction(*shape, 1.0)                                                                         
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER);
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,wy-1), cpv(_B,wx-1,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                       ;
  cpShapeSetFriction(*shape, 1.0)                                                                         ;
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)                                                          ;
  
  *shape = cpSpaceAddShape(*space, cpSegmentShapeNew(*staticBody, cpv(_A,wx-1,0), cpv(_B,0,0), 0.0));
  cpShapeSetElasticity(*shape, 1.0)                                                                 ;
  cpShapeSetFriction(*shape, 1.0)   
  cpShapeSetFilter(*shape, NOT_GRABBABLE_FILTER)   ;
  
  For i= 0 To 100; 
    *body.cpBody = add_box_tank(*space, 20, 1);
    
    *pivot.cpConstraint = cpSpaceAddConstraint(*space, cpPivotJointNew2(*staticBody, *body, cpvzero, cpvzero));
    cpConstraintSetMaxBias(*pivot, 0)                                                                         ; // disable joint correction
    cpConstraintSetMaxForce(*pivot, 1000.0)                                                                   ; // emulate linear friction
    
    *gear.cpConstraint = cpSpaceAddConstraint(*space, cpGearJointNew(*staticBody, *body, 0.0, 1.0));
    cpConstraintSetMaxBias(*gear, 0)                                                               ; // disable joint correction
    cpConstraintSetMaxForce(*gear, 5000.0)                                                         ; // emulate angular friction
  Next
  
  ; We joint the tank To the control body And control the tank indirectly by modifying the control body.
  *tankControlBody = cpSpaceAddBody(*space, cpBodyNewKinematic());
  *tankBody = add_box_tank(*space, 30, 10)                            ;
  
  *pivot.cpConstraint = cpSpaceAddConstraint(*space, cpPivotJointNew2(*tankControlBody, *tankBody, cpvzero, cpvzero));
  cpConstraintSetMaxBias(*pivot, 0)                                                                                  ; // disable joint correction
  cpConstraintSetMaxForce(*pivot, 10000.0)                                                                           ; // emulate linear friction
  
  *gear.cpConstraint = cpSpaceAddConstraint(*space, cpGearJointNew(*tankControlBody, *tankBody, 0.0, 1.0));
  cpConstraintSetErrorBias(*gear, 0)                                                                      ; // attempt to fully correct the joint each step
  cpConstraintSetMaxBias(*gear, 1.2)                                                                      ; // but limit it's angular correction rate
  cpConstraintSetMaxForce(*gear, 50000.0)                                                                 ; // emulate angular friction
EndProcedure


Procedure updateFuncTank()
  ;turn the control body based on the angle relative To the actual body
  *mouseDelta.cpVect = cpvsub(_A, ChipmunkDemoMouse, cpBodyGetPosition(_B,*tankBody));
  turn.cpFloat = cpvtoangle(cpvunrotate(_A, cpBodyGetRotation(_B, *tankBody), *mouseDelta));
  cpBodySetAngle(*tankControlBody, cpBodyGetAngle(*tankBody) - turn)
  
  ; drive the tank towards the mouse
  hit.a = cpvnear(ChipmunkDemoMouse, cpBodyGetPosition(_A, *tankBody), 30.0)
  If hit = 1
    cpBodySetVelocity(*tankControlBody, cpvzero); // stop
  Else
    If cpvdot(*mouseDelta, cpBodyGetRotation(_A, *tankBody)) > 0.0 
      direction = 1.0
    Else
      direction = -1.0
    EndIf
    cpBodySetVelocity(*tankControlBody, cpvrotate(_A, cpBodyGetRotation(_B, *tankBody), cpv(_C, 30.0*direction, 0.0)));
  EndIf
  
  updateFunc()
EndProcedure


Procedure destroyFuncTank()
  destroyFunc()
EndProcedure


AddElement(ChipmunkDemo())
ChipmunkDemo()\title = "Tank"
ChipmunkDemo()\timestep = 1.0/20
ChipmunkDemo()\initFunc = @initFuncTank()
ChipmunkDemo()\updateFunc = @updateFuncTank()
ChipmunkDemo()\destroyFunc = @destroyFuncTank()
ChipmunkDemo()\description = "Move the mouse moves the big box too"
; IDE Options = PureBasic 5.70 LTS beta 1 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableXP